=== lib/openssl/CMakeLists.txt ===
# only headers, no target.
