=== build/debian/changelog ===
wiznote (2.0.62-1ppa1) precise; urgency=medium

  * see changelog

 -- Albert.Zhou (Wiz) <albert748@gmail.com>  Mon, 04 Nov 2013 04:02:58 +0800

wiznote (2.0.59-1ppa1) precise; urgency=medium

  * see changelog

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Fri, 01 Nov 2013 13:54:24 +0000

wiznote (2.0.56-1ppa1) precise; urgency=medium

  * see changelog

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Thu, 24 Oct 2013 19:05:21 +0000

wiznote (2.0.50-1ppa1) precise; urgency=medium

  * see changelog

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Thu, 24 Oct 2013 19:05:21 +0000

wiznote (2.0.46-1ppa1) precise; urgency=medium

  * see changelog

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Tue, 22 Oct 2013 18:59:30 +0000

wiznote (2.0.38-1ppa2) precise; urgency=medium

  * New modern theme
  * Rewrite of syncing backend, more stable, more fast
  * Support Biz enterprise group category
  * etc..

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Sun, 20 Oct 2013 19:49:26 +0800

wiznote (1.5.18-0ppa1~raring1) raring; urgency=low

  * 1.5.18: [critical] bug fix

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Mon, 03 Jun 2013 16:38:47 +0800

wiznote (1.5.16-0ppa1~raring1) raring; urgency=low

  * 1.5.16: bug fix

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Thu, 30 May 2013 22:04:45 +0800

wiznote (1.5.14-0ppa1~raring1) raring; urgency=low

  * 1.5.14: bug fix

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Tue, 28 May 2013 17:50:18 +0800

wiznote (1.5.13-0ppa1~raring1) raring; urgency=low

  * 1.5.13 release

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Tue, 28 May 2013 14:09:51 +0800

wiznote (1.5.1-0ppa1~raring2) raring; urgency=low

  * 1.5.1 release

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Tue, 30 Apr 2013 18:30:46 +0800

wiznote (1.4.11-0ppa1~quantal1) quantal; urgency=low

  * 1.4.11 release

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Wed, 27 Feb 2013 15:54:25 +0800

wiznote (1.4.0-1) precise; urgency=low

  * Initial debian package

 -- Albert.Zhou (wiz) <albert748@gmail.com>  Wed, 20 Feb 2013 16:03:56 +0800
