=== build/debian/control ===
Source: wiznote
Section: graphics
Priority: standard
Maintainer: Albert.Zhou <albert.zhou@wiz.cn>
Build-Depends: debhelper (>= 9), cmake (>= 2.8), libqt4-dev (>= 4.8), libqtwebkit-dev, zlib1g-dev
Standards-Version: 2.0.62
Homepage: http://www.wiznote.com

Package: wiznote
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross platform cloud based note-taking application
 WizNote is a cross platform cloud based note-taking application.
 .
 support following platforms:
 1. windows xp/vista/7/8.
 2. Mac OSX.
 3. Linux
 3. Android/IOs.
 4. Web
 .
 please refer to WizNote home for more detailed info: http://www.wiznote.com.
